<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="网络名称" prop="netName">
        <el-input
          v-model="queryParams.netName"
          placeholder="请输入网络名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['netEwm:net:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['netEwm:net:edit']"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['netEwm:net:remove']"
          >删除</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['netEwm:net:export']"
          >导出</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="netList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />

      <el-table-column label="网络名称" align="center" prop="netName" />
      <el-table-column label="wifi名称" align="center" prop="wifiName" />
      <el-table-column label="wifi密码" align="center" prop="wifiPass" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-download"
            @click="handleCode(scope.row)"
            >下载二维码</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['netEwm:net:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['netEwm:net:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改网络对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="网络名称" prop="netName">
          <el-input v-model="form.netName" placeholder="请输入网络名称" />
        </el-form-item>

        <el-form-item label="wifi名称" prop="wifiName">
          <el-input v-model="form.wifiName" placeholder="请输入wifi名称" />
        </el-form-item>
        <el-form-item label="wifi密码" prop="wifiPass">
          <el-input v-model="form.wifiPass" placeholder="请输入wifi密码" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog
      title="WI-FI码"
      :visible.sync="wifiopen"
      width="420px"
      append-to-body
    >
      <div ref="downloadElement" style="padding: 20px 10px">
        <img :src="code.imgs" alt="" class="codeImg" />
        <div class="netName">WI-FI名称：{{ code.wifiName }}</div>
      </div>

      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleUpload()">下载图片</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listNet, getNet, delNet, addNet, updateNet } from "@/api/netEwm/net";
import { mapGetters } from "vuex";
import { getCode } from "@/api/login.js";
import html2canvas from "html2canvas";
export default {
  name: "Net",
  data() {
    return {
      wifiopen: false,
      code: {
        imgs: "",
        netName: "",
      },
      imgs: null,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 网络表格数据
      netList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        netName: null,
        shanghuId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.queryParams.shanghuId = this.shanghuId;
    this.getList();
  },
  computed: {
    ...mapGetters(["shanghuId"]),
  },
  methods: {
    handleUpload() {
      const downloadElement = this.$refs.downloadElement;
      // 使用html2canvas将元素转换为Canvas
      html2canvas(downloadElement).then((canvas) => {
        // 获取Canvas的Base64编码
        const base64Image = canvas.toDataURL("image/png");

        // 创建一个虚拟的下载链接
        const downloadLink = document.createElement("a");
        downloadLink.href = base64Image;
        downloadLink.download = "downloaded_image.png";

        // 模拟点击下载链接
        downloadLink.click();
      });
    },
    handleCode(row) {
      let data = {
        path: "pages/index/index",
        posterId: row.id,
      };
      getCode(data).then((res) => {
        this.code.imgs = "data:image/png;base64," + res.data;
        this.code.wifiName = row.wifiName;
        this.wifiopen = true;
      });
    },
    /** 查询网络列表 */
    getList() {
      this.loading = true;
      listNet(this.queryParams).then((response) => {
        this.netList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        shanghuId: null,
        netName: null,
        wifiName: null,
        wifiPass: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加网络";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getNet(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改网络";
      });
    },
    /** 提交按钮 */
    submitForm() {
      if (!this.shanghuId) {
        this.$modal.msgError("您不是商户！");
        return;
      }
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateNet(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            this.form.shanghuId = this.shanghuId;
            addNet(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除网络编号为"' + ids + '"的数据项？')
        .then(function () {
          return delNet(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "netEwm/net/export",
        {
          ...this.queryParams,
        },
        `net_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
<style scoped>
.codeImg {
  width: 100%;
  height: 350px;
}
.netName {
  margin-top: 6px;
  text-align: center;
  font-size: 16px;
  font-weight: bold;
}
</style>
